﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class DemoAresSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct($tv)
    {
        parent::__construct(self::ID);
        $this->tv = $tv;
    }

    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $show_tv = isset($plugin_cookies->show_tv) ? $plugin_cookies->show_tv : 'yes';
        //$show_vod = isset($plugin_cookies->show_vod) ? $plugin_cookies->show_vod : 'yes';
        $use_proxy = isset($plugin_cookies->use_proxy) ? $plugin_cookies->use_proxy : 'no';
        $proxy_ip = isset($plugin_cookies->proxy_ip) ? $plugin_cookies->proxy_ip : '192.168.0.1';
        $proxy_port = isset($plugin_cookies->proxy_port) ? $plugin_cookies->proxy_port : '8080';

        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';

        $this->add_label ($defs, 'Itnet IPTV plugin:', DemoConfig::PLUGIN_VERSION);
        //$this->add_combobox ($defs, 'show_tv', 'Itnet IPTV в разделе ТВ:', $show_tv, $show_ops, 0, true);
        if (DemoConfig::arescam_auth_mode === DemoConfig::AUTH_LOGIN_AND_REGISTER) {
            $this->add_button ($defs, 'register_button', null, 'Регистрация', 400);
        }
        $this->add_combobox ($defs, 'use_proxy', 'Использовать Proxy для UDP:', $use_proxy, $show_ops, 0, true);
        if ($use_proxy == 'yes') {
            $this->add_text_field ($defs, 'proxy_ip', 'Адрес proxy-сервера (IP или DNS):', $proxy_ip,
                                    false, false, false, true, 500, false, true);
            $this->add_text_field ($defs, 'proxy_port', 'Порт proxy-сервера:', $proxy_port,
                                    true, false, false,  true, null, false, true);
        }

        return $defs;
    }

    private function do_registration_form_defs (&$plugin_cookies)
    {
        $defs = array ();

        $username = isset($plugin_cookies->username) ? $plugin_cookies->username : '';
        $password = isset($plugin_cookies->password) ? $plugin_cookies->password : '';
        $unregister = isset($plugin_cookies->unregister) ? $plugin_cookies->unregister : false;

        $this->add_text_field ($defs, 'username', 'Абонент:', $username,
                                false/*numeric*/, false, false, false, 500);
        $this->add_text_field ($defs, 'password', 'Пароль:', $password,
                                false/*numeric*/, true, false, false, 500);
        $this->add_vgap ($defs, 50);
        $this->add_button ($defs, 'register_terminal', null, 'Регистрация', 400);
        if ($unregister === true) {
            //$this->add_vgap ($defs, -3);
            $this->add_button ($defs, 'unregister_terminal', null, 'Дерегистрация', 400);
        }
        //$this->add_vgap ($defs, -3);
        $this->add_close_dialog_button ($defs, 'Отменить', 400);

        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print ('--> Entry handler: handle_user_input:');
        foreach ($user_input as $key => $value) {
            hd_print ("  $key => $value");
        }
        if (!isset ($user_input->control_id)/*$user_input->selected_media_url === 'tv_group_list'*/) {
            $res = $this->tv->login_terminal (null);
            if ($res) {
                return ActionFactory::open_folder ();
            }
            return ActionFactory::show_dialog ('Введите регистрационные данные', $this->do_registration_form_defs ($plugin_cookies), true);
        }
        if ($user_input->action_type === 'confirm' || $user_input->action_type === 'apply' )
        {
            $control_id = $user_input->control_id;
            //$new_value = $user_input->{$control_id};
            //hd_print("Setup: changing $control_id value to $new_value");

            if ($control_id === 'show_tv') {
                $plugin_cookies->show_tv = $user_input->show_tv;
            } else if ($control_id === 'use_proxy') {
                $plugin_cookies->use_proxy = $user_input->use_proxy;
                $plugin_cookies->proxy_ip = isset ($plugin_cookies->proxy_ip) ? $plugin_cookies->proxy_ip : '192.168.0.1';
                $plugin_cookies->proxy_port = isset ($plugin_cookies->proxy_port) ? $plugin_cookies->proxy_port : '8080';
            } else if ($control_id === 'proxy_ip') {
                $plugin_cookies->proxy_ip = $user_input->proxy_ip;
            } else if ($control_id === 'proxy_port') {
                $plugin_cookies->proxy_port = $user_input->proxy_port;
            } else if ($control_id === 'register_button') {
                $res = $this->tv->login_terminal (0);
                $plugin_cookies->unregister = $res;
                return ActionFactory::show_dialog ('Введите регистрационные данные', $this->do_registration_form_defs ($plugin_cookies), true);
            } else if ($control_id === 'register_terminal') {
                if (is_null ($user_input->username) || trim ($user_input->username) === '') {
                    return ActionFactory::show_error (false, 'Ошибка', array ('Имя абонента не может быть пустым.'));
                } else if (is_null ($user_input->password) || trim ($user_input->password) === '') {
                    return ActionFactory::show_error (false, 'Ошибка', array ('Пароль не может быть пустым.'));
                }
                $res = $this->tv->register_terminal ($user_input->username, $user_input->password);
                if ($res) {
                    $plugin_cookies->username = $user_input->username;
                    $plugin_cookies->password = $user_input->password;
                    if ($user_input->selected_media_url == 'setup') {
                        return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog ('Регистрация выполнена'));
                    }
                    return ActionFactory::close_dialog_and_run (ActionFactory::open_folder ());
                } else {
                    return ActionFactory::show_error (false, 'Ошибка', array ('Неправильное имя абонента или пароль.'));
                }
            } else if ($control_id === 'unregister_terminal') {
                $res = $this->tv->unregister_terminal ();
                if ($res) {
                    if ($user_input->selected_media_url == 'setup') {
                        return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog  ('Дерегистрация выполнена.'));
                    }
                }
                return ActionFactory::show_error (false, 'Ошибка', array ('Дерегистрация не выполнена.'));
            }
        }

        return ActionFactory::reset_controls ($this->do_get_control_defs ($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
